uva live 2326 - Moving Tables

把房间号映射在一条坐标上,然后排序,最后找从左到右找一次可行的计划,最后找从左到右找一次可行的计划,最后找从左到右找一次可行的计划,最后找从左到右找一次可行的计划,

............

次数*10就是答案

#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstring>
using namespace std;
struct node
{
    int s,e;
};
istream & operator >>(istream &is,node &a)
{
    is>>a.s>>a.e;
    return is;
}
bool cmp(node a,node b)
{
    return a.s!=b.s?a.s<b.s:a.e<b.e;
}
int cg(int x)
{
    return x&1?(x+1)>>1:x>>1;
}
int main()
{
   // freopen("in","r",stdin);
    bool vis[210];
    int T,i,j,n,ans;
    node box[210];
    node p;
    cin>>T;
    while(T--)
    {
        cin>>n;
        for(i=0;i<n;i++)
        {
            cin>>box[i];
            box[i].s=cg(box[i].s);
            box[i].e=cg(box[i].e);
            if(box[i].s>box[i].e)
                swap(box[i].s,box[i].e);
        }
        ans=0;
        memset(vis,0,sizeof(vis));
        sort(box,box+n,cmp);
        for(i=0;i<n;i++)
        {
            if(vis[i])
                continue;
            ans+=10;
            p=box[i];
            for(j=i+1;j<n;j++)
            {
                if(vis[j])
                    continue;
                if(box[j].s>p.e||box[j].e<p.s)
                {
                    vis[j]=1;
                    p=box[j];
                }
            }
        }
        cout<<ans<<endl;
    }
    return 0;
}

mous ACM (Advanced Computer Maker) Company has rented a floor ofa building whose shape is inthe following figure.


The floor has 200 rooms each on the north side and south side along thecorridor. Recently the Companymade a plan to reform its system. The reform includes moving a lot oftables between rooms. Because thecorridor is narrow and all the tables are big, only one
table can passthrough the corridor. Some plan is neededto make the moving efficient. The manager figured out the followingplan: Moving a table from a room toanother room can be done within 10 minutes. When moving a table fromroomi
to room j, the part of thecorridor between the front of room i
and the front of room jis used. So, during each 10 minutes, severalmoving between two rooms not sharing the same part of the corridor willbe done simultaneously. To make itclear the manager illustrated the possible cases and impossible casesof simultaneous
moving.

  Table moving Reason
Possible ( room 30 to room 50) and (room60 to room 90) no part of corridor is shared
(room 11 to room 12) and (room14 to room 13) no part of corridor is shared
Impossible (room 20 to room 40) and (room31 to room 80) corridor in front of room 31 toroom 40 is shared
(room 1 to room 4) and (room 3to room 6) corridor in front of room 3 isshared
(room 2 to room 8) and (room 7to room 10) corridor in front of room 7 isshared

For each room, at most one table will be either moved in or moved out.Now, the manager seeks out a methodto minimize the time to move all the tables. Your job is to write aprogram to solve the manager‘s problem.

Input

The input consists of T test cases. The number of test cases (T) is given in the first line of the input file. Eachtest case begins with a line containing an integerN
, 1<=N<=200 , that represents thenumber of tables to move.Each of the followingN
lines contains two positive integers sand t, representing that a table is to move fromroom numbers
to room number t (each room numberappears at most once in theN
lines). From the N+3-rdline, the remaining test cases are listed in the same manner as above.

Output

The output should contain the minimum time in minutes to complete themoving, one per line.

Sample Input

3
4
10 20
30 40
50 60
70 80
2
1 3
2 200
3
10 100
20 80
30 50

Sample Output

10
20
30

时间: 2024-10-21 13:03:16

uva live 2326 - Moving Tables的相关文章

UVALive - 2326 Moving Tables 贪心

题目大意:有400个箱子,奇数的箱子在北边,偶数的箱子在南边,每个箱子的大小都一样.北边和南边之间有一条走廊,走廊的宽度刚好是一个箱子的宽度. 现在有M个移动操作,工人每次移动箱子需要10分钟(你有无限个工人,因为有走廊的约束,不能有两个箱子公用一段走廊).问需要多少分钟能把这些操作做完 解题思路:先将奇数的箱子和偶数的箱子做一下处理,避免1 3和4 6操作只需要10分钟这种情况.输入的时候要注意,输入的第一个数有可能小于第二个数. #include<cstdio> #include<c

poj1083 Moving Tables

Moving Tables Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 26782   Accepted: 8962 Description The famous ACM (Advanced Computer Maker) Company has rented a floor of a building whose shape is in the following figure. The floor has 200

hdu1050&amp;&amp;nyoj220 Moving Tables(贪心)

Moving Tables Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 24372    Accepted Submission(s): 8071 Problem Description The famous ACM (Advanced Computer Maker) Company has rented a floor of a

hdoj 1050 Moving Tables【贪心区间覆盖】

Moving Tables Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 24316    Accepted Submission(s): 8053 Problem Description The famous ACM (Advanced Computer Maker) Company has rented a floor of a b

HDU1050(Moving Tables:贪心算法)

解题思路: 这种做法是基于hdu2037的做法上考虑的,找出所有可以同时搬运的桌子,然后就很方便求出最短总时间. 还有一种更简单的做法是直接遍历一遍找出与别的重复次数最多的那片区域,重复次数*10就可以得到结果. Moving Tables Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 28033    Accepted Submis

HDU 1050 Moving Tables

Moving Tables Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 23044    Accepted Submission(s): 7749 Problem Description The famous ACM (Advanced Computer Maker) Company has rented a floor of a

HDU 1050 Moving Tables (贪心)

Moving Tables Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 20302    Accepted Submission(s): 6889 Problem Description The famous ACM (Advanced Computer Maker) Company has rented a floor of a

HDU1050:Moving Tables

Moving Tables Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 19156    Accepted Submission(s): 6532 Problem Description The famous ACM (Advanced Computer Maker) Company has rented a floor of a

poj 1579 Moving Tables(水)

Description The Recaman's sequence is defined by a0 = 0 ; for m > 0, a m = a m−1 − m if the rsulting a m is positive and not already in the sequence, otherwise a m = am−1 + m. The first few numbers in the Recaman's Sequence is 0, 1, 3, 6, 2, 7, 13, 2